function [ln_rho, pole] = circularityNorthPoleConstraint(p, q, lambda)
[rows, cols] = size(p);

%pointCount = rows*cols;
pointCount = rows*cols + 1;
%eqCount = 2 * ((rows-1) * cols) + rows;
eqCount = 2 * ((rows-1) * cols) + rows + cols;

M = sparse(eqCount, pointCount);
b = zeros(eqCount, 1);

eqId = 0;
inverseOfdTheta = lambda/pi;

for row = 1:rows-1
    for col = 1:cols-1
        eqId = eqId + 1;

        M(eqId, (row-1)*cols + col) = -inverseOfdTheta;
        M(eqId, (row-1)*cols + col + 1) = inverseOfdTheta;
        b(eqId, 1) = q(row, col);
        
        eqId = eqId + 1;
        M(eqId, (row-1)*cols + col) = -inverseOfdTheta;
        M(eqId, row*cols + col) = inverseOfdTheta;
        b(eqId, 1) = p(row, col);
    end
    
    col = cols;
    eqId = eqId + 1;
    M(eqId, (row-1)*cols + col) = -inverseOfdTheta;
    M(eqId, (row-1)*cols + 1) = inverseOfdTheta;
    b(eqId, 1) = q(row, col);
   
    eqId = eqId + 1;
    M(eqId, (row-1)*cols + col) = -inverseOfdTheta;
    M(eqId, row*cols + col) = inverseOfdTheta;
    b(eqId, 1) = p(row, col);
end

row = rows;
for col = 1:cols-1
    eqId = eqId + 1;
    M(eqId, (row-1)*cols + col) = -inverseOfdTheta;
    M(eqId, (row-1)*cols + col + 1) = inverseOfdTheta;
    b(eqId, 1) = q(row, col);
end

col = cols;
eqId = eqId + 1;
M(eqId, (row-1)*cols + col) = -inverseOfdTheta;
M(eqId, (row-1)*cols + 1) = inverseOfdTheta;
b(eqId, 1) = q(row, col);

% Pole!
row = 1;
for col = 1:cols
    eqId = eqId + 1;
    M(eqId, row*cols+col) = -inverseOfdTheta;
    M(eqId, rows*cols + 1) = inverseOfdTheta;
    b(eqId, 1) = -p(row, col);
end

X = M \ b;

ln_rho = zeros(row, col);
eqId = 0;

for row = 1:rows
    for col = 1:cols
        eqId = eqId + 1;
        ln_rho(row, col) = X(eqId, 1);
    end
end

% Pole!
pole = X(end, 1);
end
