%
% References :
%   -
%
% Author:  Jordan Caracotte, Fabio Morbidi and El Mustapha Mouaddib
% Date:    2019-06-18
% Version: 1.0
% Umail:   jordan.caracotte@etud.u-picardie.fr
% URL:     https://mis.u-picardie.fr/~fabio/ustereo.html
%
% (c) 2019 Jordan Caracotte, Fabio Morbidi and El Mustapha Mouaddib, 
% MIS Laboratory, University of Picardie Jules Verne, Amiens, France
%
% History:
%   Date:       Version       Comment:
%   2019-06-08  1.0.20190608  Original Version
%

function [engine] = computeErrors(engine)

[m,n] = size(engine.estimation);

for i = 1:m
    for j = 1:n
        engine.estimation{i, j}.errors = {};
        engine.estimation{i, j}.errors.v = engine.estimation{i, j}.N - engine.data{i, j}.N;
        engine.estimation{i, j}.errors.angle = acos( dot( ...
            engine.data{i, j}.N, ...
            engine.estimation{i, j}.N ...
        ));
        engine.estimation{i, j}.errors.rho = engine.estimation{i, j}.rhoNorm - engine.data{i, j}.rhoNorm;
    end
end

