%
% References :
%   -
%
% Author:  Jordan Caracotte, Fabio Morbidi and El Mustapha Mouaddib
% Date:    2019-06-18
% Version: 1.0
% Umail:   jordan.caracotte@etud.u-picardie.fr
% URL:     https://mis.u-picardie.fr/~fabio/ustereo.html
%
% (c) 2019 Jordan Caracotte, Fabio Morbidi and El Mustapha Mouaddib, 
% MIS Laboratory, University of Picardie Jules Verne, Amiens, France
%
% History:
%   Date:       Version       Comment:
%   2019-06-08  1.0.20190608  Original Version
%

function [engine] = OMNI_computeNormals(engine)
fprintf('Estimating normal vectors... ');

phi = engine.parameters.phi;
theta = engine.parameters.theta;

engine.estimation = cell(length(theta), length(phi));
lights = engine.parameters.lights;

for i = 1:length(theta)
    for j = 1:length(phi)
        [ p, q ] = computePQ(engine.data{i, j}.I, lights, theta(i), phi(j));
        
        engine.estimation{i, j}.p = -p;
        engine.estimation{i, j}.q = -q;
        engine.estimation{i, j}.N = 1/sqrt(p^2 + (q/sin(theta(i)))^2 + 1) * rotoz(phi(j)) * rotoy(theta(i)) * [ -p, -q/sin(theta(i)), -1 ]';
    end
end

fprintf('OK!\n');
